import random

MOD = 10**9
f = 1

breaks = []


def count_a(start, n, columns):
    min_a = 10 ** 9
    a = 0
    for i in range(n):
        a = max(a, columns[(start + i) % n])
        a += 1
    new_min_a = a - n
    if new_min_a < min_a:
        min_a = new_min_a
    return min_a


def solve_slow(n, columns):
    min_a = 10**9
    g_start = 0
    for start in range(n):
        a = count_a(start, n, columns)
        if a < min_a:
            g_start = start
            min_a = a

    return min_a, g_start + 1


def solve_fast(n, columns):
    max_column = 0
    for i in range(1, n):
        if columns[i] > columns[max_column]:
            max_column = i
    a = columns[max_column]
    break_a = a
    start_index = (max_column + 1) % n + 1
    break_ind = start_index
    for i in range(1, n):
        # print(n)
        # print((max_column - i) % n)
        index = (max_column - i) % n
        a -= 1
        # print(columns[index], index, max_column)
        if columns[index] > a:
            a = columns[index]
        if a < break_a:
            break_a = a
            break_ind = index + 1
        # print(a)
    a = count_a(break_ind-1, n, columns)
    return a, break_ind


def compare():
    for n in range(1, 100):
        cls = [random.randint(1, 1000) for i in range(n)]
        if solve_fast(n, cls) != solve_slow(n, cls):
            print(n, cls)
            print('fast', solve_fast(n, cls))
            print('slow', solve_slow(n, cls))
    print('Compared')


# compare()


def solve():
    global f
    global breaks
    n = int(input())
    f = int(input())

    if f == 1:
        columns = [int(i)for i in input().split()]
        breaks = [1] * n
    else:
        maxim = 0
        maxim_i = 0
        m, x, y, z = [int(i)for i in input().split()]
        columns = [int(i)for i in input().split()]
        breaks = [1] * m
        prev = 0
        if y == 0 == x:
            for i in range(m, n):
                columns[i] = ((x * columns[i - 2] + y * columns[i - 1] + z) % MOD) + 1
        else:
            brs = 0
            post_prev = columns[-2]
            prev = columns[-1]
            for i in range(m, n):
                # print(columns, i)
                new_column = ((x * post_prev + y * prev + z) % MOD) + 1
                if new_column > prev:
                    brs += 1
                else:
                    # print('add', prev)
                    columns.append(prev - brs + 1)
                    breaks.append(brs)
                    brs = 1
                post_prev = prev
                prev = new_column
            columns.append(prev - brs + 1)
            breaks.append(brs)
            # breaks.append(1)
            # print(breaks)
            # print(columns)
            # if columns[i] > maxim:
            #     maxim_i = i
            #     maxim = columns[maxim_i]
            # a = maxim - n + 1
            # print(a, 1)
            # exit()

    # print(columns)
    print(*solve_fast(len(columns), columns))


solve()
