n, m = map(int, input().split())
ms = min(n, m)
A = [int(i) for i in input().split()]
B = [int(i) for i in input().split()]


def sum_lists(a, b):
    return [a[i] + b[i] for i in range(len(a))]


def is_palindrome(a) -> bool:
    return a[:] == a[::-1]


L_ans = 0
R_ans = ms + 1
ans = 0
while L_ans < R_ans:
    ans = (R_ans + L_ans) // 2
    ok = False
    for start_a in range(n - ans + 1):
        for start_b in range(m - ans + 1):
            a_slice = A[start_a:start_a + ans]
            b_slice = B[start_b:start_b + ans]
            # print(a_slice, b_slice)
            total_slice = sum_lists(a_slice, b_slice)
            # print(total_slice)
            if is_palindrome(total_slice):
                ok = True
                break
        if ok:
            break
    if ok:
        if L_ans == R_ans - 1:
            R_ans = L_ans
        L_ans = ans
    else:
        R_ans = ans
print(L_ans)