#include <cstdio>
#include <algorithm>
#include <vector>

struct Div {
	long long a;
	long long b;
};

long long get_nod(long long a, long long b) {
	if (a == b) return a;
	if (b > a) return get_nod(b, a);
	if (b == 0) return a;
	return get_nod	(b, a % b);
}

bool operator < (Div a, Div b) {
	return a.a * b.b < a.b * b.a;
}


int main()
{
	int n, q;
	scanf_s("%d %d", &n, &q);
	std::vector<long long> a (n);
	std::vector<long long> b (n);
	std::vector<Div> ints (n*n+1);
	for (int i = 0; i < n; i++) {
		scanf_s("%lld", &a[i]);
	}
	for (int i = 0; i < n; i++) {
		scanf_s("%lld", &b[i]);
	}
	std::sort(a.begin(), a.end());
	std::sort(b.begin(), b.end());
	std::reverse(b.begin(), b.end());
	// need to a / b
	/*for (int i = 0; i < n; i++) {
		printf("%d ", a[i]);
	}
	for (int i = 0; i < n; i++) {
		printf("%d ", b[i]);
	}*/
	/* ints[1] = { 0, 0 };
	ints[n*n] = { n, n };


	for (int num = 1; num < n * n; num++) {
		ints[num] = { num / n, num % n };
	} */


	for (int num = 1; num <= n * n; num++) {
		ints[num] = { a[(num-1) / n], b[(num-1) % n] };
	}
	ints[0] = { 1, 99999999999 };
	std::sort(ints.begin(), ints.end());
	/*
	int cur_a = 0;
	int cur_b = 0;
	int tar_a = 0;
	int tag_b = 0;
	for (int num = 2; num < n * n; num++) {
		// printf("%d %d\n", cur_a, cur_b);
		// printf("%d %d\n", a[cur_a + 1] * b[cur_b + 1], a[cur_a] * b[cur_b]);
		if (cur_b >= (n - 1) || cur_a-1 < n && (a[cur_a + 1] * b[cur_b + 1] < a[cur_a] * b[cur_b])) cur_a++;
		else cur_b++;
		ints[num] = { cur_a, cur_b };
		if (cur_b < n - 1) cur_a = 0;
	}*/	

	for (int i = 0; i < q; i++) {
		int c;
		scanf_s("%d", &c);
		long long get_a = ints[c].a;
		long long get_b = ints[c].b;
		if (get_a == 0 || get_b == 0) continue;
		long long nod = get_nod(get_a, get_b);
		get_a /= nod;
		get_b /= nod;
		printf("%lld %lld", get_a, get_b);
		if (i < q - 1) printf("\n");
	}
}
