#include <cstdio>
#include <queue>
#include <vector>

int main()
{
	int n, k;
	scanf_s("%d %d", &n, &k);
	std::vector<int> presents(n);
	int max = -1000000000;
	for (int i = 0; i < n; i++) {
		scanf_s("%d", &presents[i]);
		if (presents[i] > max) max = presents[i];
	}
	if (max <= 0) {
		if (k) printf("0");
		else printf("%d", max);
		return 0;
	}
	std::priority_queue<int> for_sister;
	int L = 0, R = 0;
	int checked_L = 0, checked_R = 0;
	int current_max = 0;
	max = 0;
	while (L < n) {
		R = L;
		current_max = 0;
		while (R < n) {
			if (presents[R] >= 0) {
				if (for_sister.size() < k) {
					for_sister.push(presents[R]);
				}
				else if (k > 0 && presents[R] > for_sister.top()) {
					current_max += for_sister.top();
					for_sister.pop();
					for_sister.push(presents[R]);
				}
				else {
					current_max += presents[R];
				}
			}
			else {
				current_max += presents[R];
			}
			if (current_max > max && for_sister.size() >= k) {
				max = current_max;
				checked_R = R;
			}
			R++;
		}
		L++;
		while (L < n && presents[L] < 0) L++;
		while (for_sister.size()) for_sister.pop();
	}
	/*
	L = R-1;
	current_max = 0;
	while (L >= 0) {
		if (presents[L] >= 0) {
			if (for_sister.size() < k) {
				for_sister.push(presents[L]);
			}
			else if (k > 0 && presents[L] > for_sister.top()) {
				current_max += for_sister.top();
				for_sister.pop();
			}
			else {
				current_max += presents[L];
			}
		}
		else {
			current_max += presents[L];
		}
		if (current_max > max && for_sister.size() >= k) {
			max = current_max;
			checked_L = L;
		}
		L--;
	} */
	printf("%d", max);
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
